﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Script.Serialization;
using CRUDandValidation.Models;
using Syncfusion.JavaScript;
using Syncfusion.JavaScript.DataSources;
using System.Net;

namespace CRUDandValidation.Controllers
{
    public class HomeController : Controller
    {
        NORTHWNDEntities db = new NORTHWNDEntities();
        public ActionResult Index()
        {
            return View();
        }

        public ActionResult Validate(Supplier Supplier)
        {
            if (!ModelState.IsValid)
            {
                return Json(new { result = ModelState.Keys.Contains(Supplier.ValidatedProperty) });
            }
            return Content("true");
        }

        public ActionResult DataSource(DataManager dm)
        {
           DataOperations ds= new DataOperations();

           var data = ds.Execute(db.Suppliers.ToList(), dm);
           return Json(new { result = data, count = db.Suppliers.ToList().Count }, JsonRequestBehavior.AllowGet);
        }

        public ActionResult Insert(Supplier value)
        {
            if (!ModelState.IsValid)
            {
                var message = string.Join(" | ", ModelState.Values
       .SelectMany(v => v.Errors)
       .Select(e => e.ErrorMessage));
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest, message);
            }
            db.Suppliers.Add(value);
            db.SaveChanges();
            return Json(db.Suppliers.ToList(), JsonRequestBehavior.AllowGet);
        }

        public ActionResult Update(Supplier value)
        {
            if (!ModelState.IsValid)
            {
                var message = string.Join(" | ", ModelState.Values
       .SelectMany(v => v.Errors)
       .Select(e => e.ErrorMessage));
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest, message);
            }
            Supplier old = db.Suppliers.Where(o => o.Id == value.Id).SingleOrDefault();
            if (old != null)
            {
                db.Entry(old).CurrentValues.SetValues(value);
                db.SaveChanges();
            }
            return Json(db.Suppliers.ToList(), JsonRequestBehavior.AllowGet);
        }

        public ActionResult Delete(Supplier value)
        {
            db.Suppliers.Remove(db.Suppliers.Where(o => o.Id == value.Id).SingleOrDefault());
            db.SaveChanges();
            return Json(db.Suppliers.ToList(), JsonRequestBehavior.AllowGet);
        }

        public ActionResult About()
        {
            ViewBag.Message = "Your application description page.";

            return View();
        }

        public ActionResult Contact()
        {
            ViewBag.Message = "Your contact page.";

            return View();
        }
    }
}